#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "resource.h"

//  Deklarationen von Win.Proceduren von Programm-Elementen:
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ChildProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK Edit_2_Proc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK Edit_1_Proc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK HelpDlgProc (HWND, UINT, WPARAM, LPARAM);
// Men:
void    AddMenu(HWND);

// Hilfs-Funktionen fr die Berechnungen:
void Init_E24(void);
void Init_mult(void);
// (5 unterschiedliche Schaltungen -> 5 Funktionen fr die Berechnungen)
void Ein_Resistor(void);
void Zwei_in_reihe(void);
void Zwei_Parallel(void);
void Drei_Parallel(void);
void R1_plus_R2parR3(void);
void R1_par_zu_R2plusR3(void);

// 5Funktionen zum zeichnen von Schaltungen:
BOOL sEinResistor(HDC);
BOOL sZweiReihe(HDC);
BOOL sZweiParallel(HDC);
BOOL sDreiParallel(HDC);
BOOL sR1plusR2parR3(HDC);
BOOL sR1parZuR2serR3(HDC);

// Konstante Texte
char szDlgClassName[]="HelpClName";
char szChildName[] = "Zeichnen";
char szEdit_2_Name[] = "Ergebnis";
char szEdit_1_Name[] = "Eingabe";
char szEdit_2[] = "Geben Sie gewnschten Wert in Ohm ein (nur Ziffern, Punkt "
                  "statt Koma, maximal 8 Zeichen), whlen Sie die Schaltung und"
                  " E-Reihe aus und bettigen Sie Button 'Berechnen'.\r\n\r\n"
                  "Die Ausgaben in diesem Feld lassen sich wie Text behandeln "
                  "(markieren, kopieren, einfgen u.s.w.)\r\n\r\nGuter "
                  "Freundschaft mit diesem Programm!";
char szHilfeText[] = 
"Brauchen Sie einen genauen Widerstandswert? \r\n\r\nDas Programm berechnet "
"Widerstnde, aus den, je nach Schaltung, gewnschter Widerstandswert sich "
"ergibt. Es probiert ALLE Werte fr jeden Widerstand durch und gibt die Werte "
"aus, die kleinste Abweichung zum gewnschtem Wert liefern."

"\r\n\r\nBenutzung des Programms:\r\nGeben Sie den gewnschten Wert ein (nur"
" Ziffern, Punkt statt Koma, maximal 8 Zeichen), whlen Sie eine Schaltung aus,"
"  sowie E-Reihe (E12 = 12 Werte pro Dekade oder E24 mit 24 Werten pro Dekade."
"\r\n(Dekade ist z.B. von 1.0 bis 10.0, oder von 2.0 bis 20.0)\r\n"
"\r\nDrucken Sie auf 'Berechnen' (Menu oder Button 'Berechnen'). In Kurze"
" zeigt das Programm die Ergebnisse.\r\n\r\n"
"Der Text mit Ergebnissen lsst sich markieren, in die Zwichenablage kopieren"
" (Strg+C) und in z.B. Word-Dokument einfgen (Strg+V).\r\n\r\n"

"E24 beinhaltet E12. E24 Werte von 1.0 bis 10 sind:\r\n"
"1.0, 1.1, 1.2, 1.3, 1.5, 1.6, 1.8, 2.0,\r\n"
"2.2, 2.4, 2.7, 3.0, 3.3, 3.6, 3.9, 4.3,\r\n"
"4.7, 5.1, 5.6, 6.2, 6.8, 7.5, 8.2, 9.1.\r\n\r\n"
"E12-Werte sind 1.0, 1.2, 1.5 ... 8,2; also einfach E24-Werte ber einen."

"\r\n\r\nMan beachte blo das die reele Bauteile immer ihre Toleranzen haben!"
" So nutzt bis auf 0,01% genau berechneter Wert nichts, wenn Bauteil(e) 5%"
" Toleranz hat (haben)!"

"\r\n\r\nDie Ausnahme-Werte sind 9.1 MOhm und 0,010 Ohm. Das sind grte und "
"kleinste Werte und bedeuten womglich entsprechend Trennung und Kurzschlu."

"\r\n\r\nAnsonsten wnsche ich Ihnen guter Freundschaft mit dem Programm, liebe"
" Elektrotechniker!";
                  
static int     i = 0; // Schaltungs-Nr. im ComboBox: 0-4;
static int     iReihe;// Nr.der E-Reihe im ComboBox "Reihe": 0->E24; 1->E12
static HWND    hWndComboBox; // Handle von Combobox zur Schaltungs-Auswahl
static HWND    hComboReihe;  // Handle von ComboBox zur Auswahl der E-Reihe 
                             // (E12 oder E24)
static HWND    hChild;       // Handle von Zeichnungs-Fenster
static HWND    hEdit_2;      // Handle von Ergebnis-Feld
static HWND    hEdit_1;      // Handle von Eingabe-Feld
static HWND    hWndDlg;      // Handle von Dailog "Hilfe"
static HWND    hHelpEdit;    // Editfeld im Doalog "Hilfe"
static HWND    hButton_1;    // Handle von Button "Berechnen"
//static HWND    hwnd;
HINSTANCE      hInst;

BOOL           bDlg = FALSE; // Dialogbox "Hilfe" wird nicht zweiites mal erzeugt,
                             // wenn bDlg TRUE ist.

static RECT    ChildRect;    // Rechteck von Zeichnungs-Fenster

static char    szEingabe[8];// Zahl wird hierein als Text eingelesen und nacher
                                // in Zahl umgewandelt.

// Variablen fr die Berechnungen:
double  E24[24];       // einzelne Widerstands-Werte
double  Mult[9];       // Multiplikatoren 1, 10, ... 100.000.000
double  R_soll;
double  Abweichung_Alt, Abweichung_Neu;
// Daten von einzelnen Widerstnden in einer Structur zusammenfassen
struct RESISTORDATA
{
  double  R;       // Widerstand (R)
  double  R_KW;    // Kehrwert (1/R)
  double  R_Wert;  // Multiplikant (Tabellenwert in E_12[12] = E_12[E_12_Nr])
  double  R_Mult;  // Multiplikator (Tabellenwert in Mult[9] = Mult[Mult_Nr])
  int     E12_Nr;  // Feld-Nr. X in Tabelle E12[X];
  int     Mult_Nr; // Feld-Nr. Y in Tabelle Mult[Y];
  char    textR[15];
};
static struct RESISTORDATA   R1, R2, R3, R_ist;

// Statische Variable fr aufnahme des Ergebnisses (Zahl) als Text
static char   stWert[15];
// Funktion fr bessere lesbarkeit des Textes (Wertes): 
// Macht aus "12000" -> "12kOhm" 
void RtoText(struct RESISTORDATA);

char szBuffer_0[150]; // fr Text von ges. Ergebnis: Wert, Abweichung, 
                      // R1 = ..., R2 = ..., R3 = .....
char szBuffer_1[25];  // Hilfsvariable fr szBuffer_0

// Men-Items-Nr.:
#define IDM_BERECHNEN 1
#define IDM_BEENDEN   2
#define IDM_HELP      3
#define IDM_INFO      4


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++ Haupt-Programm +++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    char szClassName[ ] = "WindowsApp";
    
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    WNDCLASSEX wcc;          // WindowClassEx Child (Zeichnung);
    WNDCLASSEX wce;          // WindowsClassEx EditBox (Ergebnise)
    WNDCLASSEX dlgcl;     // Dialog-Classe ("Hilfe"-Dialog)
    
    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;/* This function is called by windows */
    wincl.style = CS_DBLCLKS;           /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (hThisInstance, MAKEINTRESOURCE(IDI_ICON));
    wincl.hIconSm = LoadIcon (hThisInstance, MAKEINTRESOURCE(IDI_ICON));
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;/* No menu */
    wincl.cbClsExtra = 0;     /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;     /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
    {
        MessageBox(NULL, "Fensterklasse 1 konnte nicht registriert werden!",
              "Error!", MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }
    
    // Fensterklasse frs Zeichnen registrieren:
    /* The Window structure */
    wcc.hInstance = hThisInstance;
    wcc.lpszClassName = szChildName;
    wcc.lpfnWndProc = ChildProc;      /* This function is called by windows */
    wcc.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wcc.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wcc.hIcon = NULL;//LoadIcon (NULL, IDI_ICON);
    wcc.hIconSm = NULL;//LoadIcon (NULL, IDI_ICON);
    wcc.hCursor = LoadCursor (NULL, IDC_ARROW);
    wcc.lpszMenuName = NULL;  /* No menu */
    wcc.cbClsExtra = 0;       /* No extra bytes after the window class */
    wcc.cbWndExtra = 0;       /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    //wcc.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    wcc.hbrBackground       = (HBRUSH) COLOR_BACKGROUND;
    //CreateSolidBrush(RGB(150, 150, 255));//GetStockObject(LTGRAY_BRUSH);//
   
    if (!RegisterClassEx (&wcc))
       {
          MessageBox(NULL, "Fensterklasse 2 konnte nicht registriert werden!",
          "Error!", MB_ICONEXCLAMATION | MB_OK);
          return 0;
        }

    // Fensterklasse (fr die Ergebnise registrieren):
    /* The Window structure */
    wce.hInstance = hThisInstance;
    wce.lpszClassName = szEdit_2_Name;
    wce.lpfnWndProc = Edit_2_Proc;      /* This function is called by windows */
    wce.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wce.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wce.hIcon = NULL;         //LoadIcon (NULL, IDI_APPLICATION);
    wce.hIconSm = NULL;       //LoadIcon (NULL, IDI_APPLICATION);
    wce.hCursor = LoadCursor (NULL, IDC_ARROW);
    wce.lpszMenuName = NULL;  /* No menu */
    wce.cbClsExtra = 0;       /* No extra bytes after the window class */
    wce.cbWndExtra = 0;       /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wce.hbrBackground       = (HBRUSH) COLOR_BACKGROUND;
    //CreateSolidBrush(RGB(150, 150, 255));//GetStockObject(LTGRAY_BRUSH);//
   
    if (!RegisterClassEx (&wce))
       {
          MessageBox(NULL, "Fensterklasse Edit_2 konnte nicht registriert werden!",
          "Error!", MB_ICONEXCLAMATION | MB_OK);
          return 0;
        }
    //---   Fenster-Klasse fr Eingabe-Feld   --------------------
    wce.lpszClassName = szEdit_1_Name;
    wce.lpfnWndProc = Edit_1_Proc;      /* This function is called by windows */
    wce.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wce.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wce.hIcon = NULL;         //LoadIcon (NULL, IDI_APPLICATION);
    wce.hIconSm = NULL;       //LoadIcon (NULL, IDI_APPLICATION);
    wce.hCursor = LoadCursor (NULL, IDC_ARROW);
    wce.lpszMenuName = NULL;  /* No menu */
    wce.cbClsExtra = 0;       /* No extra bytes after the window class */
    wce.cbWndExtra = 0;       /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    //CreateSolidBrush(RGB(150, 150, 255));//GetStockObject(LTGRAY_BRUSH);//
   
    if (!RegisterClassEx (&wce))
       {
          MessageBox(NULL, "Fensterklasse Edit_2 konnte nicht registriert werden!",
          "Error!", MB_ICONEXCLAMATION | MB_OK);
          return 0;
        }
    
    // Dialog-Classe registrieren (fr "Hilfe"-DialogBox):
    dlgcl.hInstance = hThisInstance;
    dlgcl.lpszClassName = szDlgClassName;
    dlgcl.lpfnWndProc = HelpDlgProc;/* This function is called by windows */
    dlgcl.style = CS_DBLCLKS;           /* Catch double-clicks */
    dlgcl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    dlgcl.hIcon = NULL,//LoadIcon (hThisInstance, MAKEINTRESOURCE(IDI_ICON));
    dlgcl.hIconSm = NULL,//LoadIcon (hThisInstance, MAKEINTRESOURCE(IDI_ICON));
    dlgcl.hCursor = LoadCursor (NULL, IDC_ARROW);
    dlgcl.lpszMenuName = NULL;/* No menu */
    dlgcl.cbClsExtra = 0;     /* No extra bytes after the window class */
    dlgcl.cbWndExtra = 0;     /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    dlgcl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&dlgcl))
    {
        MessageBox(NULL, "Fensterklasse von Hilfe-Dialog konnte nicht"
        " registriert werden!", "Error!", MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }
    
    // Kopiere Instance in Globale variable (fr DialogBox "Hilfe"): 
    hInst = hThisInstance;
    
    //-----------------------
    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           WS_EX_CLIENTEDGE,    /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "R's (Berechnung von Widerstnden)",       /* Title Text */
           WS_CAPTION | WS_SYSMENU,//WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           520,                 /* The programs width */
           380,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);
    UpdateWindow(hwnd);
    
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }
    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}//WinMain Ende



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----------------------------------------------------------------------------
//  This function is called by the Windows function DispatchMessage()
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, 
                                 LPARAM lParam)
{
PAINTSTRUCT ps;
HDC         hdc;

  switch (message)                  // handle the messages
    {

        case WM_CREATE:
        { 
          // Zeichnungsfeld erzeugen:
          hChild = CreateWindowEx(WS_EX_CLIENTEDGE, 
                                 szChildName,//szClassName,//
                                 "Child-Fenster",
                                 WS_CHILD | WS_VISIBLE | WS_DLGFRAME,
                                 20,
                                 60,
                                 210,
                                 264,
                                 hwnd,// Parent: hwnd
                                 NULL,
                                 ((LPCREATESTRUCT) lParam)->hInstance,
                                 NULL);
          if (!hChild)
                MessageBox(NULL, "ZeichnungsBox konnte nicht erzeugt werden.", 
                                 "Error", MB_OK | MB_ICONERROR);
          //-------------------------------------------------------------------                       
          // ComboBox (Schaltungs-Wahl als Text) erzeugen:
          hWndComboBox = CreateWindowEx(0, "COMBOBOX", TEXT(""), 
                                 WS_VISIBLE | WS_CHILD | CBS_DROPDOWN,
                                 25, //xStart 
                                 30, // yStart
                                 120, // Breite, 
                                 150, // Hhe, 
                                 hwnd, 
                                 NULL, 
                                 ((LPCREATESTRUCT) lParam)->hInstance,
                                 NULL);
             
             if (!hWndComboBox)
                MessageBox(NULL, "ComboBox konnte nicht erzeugt werden.", 
                                 "Error", MB_OK | MB_ICONERROR);
             //----------------------------------------------------------------             
             // ComboBox mit 5 Eintrgen fllen:
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_0, 
                                                     (LPARAM)"R1");
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_1, 
                                                     (LPARAM)"R1 + R2");
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_2, 
                                                     (LPARAM)"R1 || R2");
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_3, 
                                                     (LPARAM)"R1 || R2 || R3");
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_4, 
                                                     (LPARAM)"R1+(R2 || R3)");
             SendMessage(hWndComboBox, CB_ADDSTRING, IDC_COMBOBOX_5, 
                                                     (LPARAM)"R1 || (R2+R3)");
             
             // Sende CB_SETCURSEL message zum ComboBox und initialisiere mit 
             //dem Inhalt 
             //  aus der Selection-Field (hier Eintrag Nr.0 =(Text:)"Eintrag 1")  
             SendMessage(hWndComboBox, CB_SETCURSEL, (WPARAM)0, (LPARAM)0);
             
             i = SendMessage((HWND) lParam, (UINT) CB_GETCURSEL, 
                                            (WPARAM) 0, (LPARAM) 0);
          
          //-------------------------------------------------------------------                       
          // ComboBox (Schaltungs-Wahl als Text) erzeugen:
          hComboReihe = CreateWindowEx(0, "COMBOBOX", TEXT(""), 
                                 WS_VISIBLE | WS_CHILD | CBS_DROPDOWN,
                                 160, //xStart 
                                 30, // yStart
                                 60, // Breite, 
                                 60, // Hhe, 
                                 hwnd, 
                                 NULL, 
                                 ((LPCREATESTRUCT) lParam)->hInstance,
                                 NULL);
             
             if (!hWndComboBox)
                MessageBox(NULL, "ComboBox 'Reihe' konnte nicht erzeugt werden.", 
                                 "Error", MB_OK | MB_ICONERROR);
             //----------------------------------------------------------------             
             // ComboBox mit 5 Eintrgen fllen:
             SendMessage(hComboReihe, CB_ADDSTRING, IDC_COMBOBOX_0, 
                                                     (LPARAM)"E24");
             SendMessage(hComboReihe, CB_ADDSTRING, IDC_COMBOBOX_1, 
                                                     (LPARAM)"E12");
             // Sende CB_SETCURSEL message zum ComboBox und initialisiere mit 
             //dem Inhalt 
             //  aus der Selection-Field (hier Eintrag Nr.0 =(Text:)"Eintrag 1")  
             SendMessage(hComboReihe, CB_SETCURSEL, (WPARAM)0, (LPARAM)0);
             
             iReihe = SendMessage((HWND) lParam, (UINT) CB_GETCURSEL, 
                                            (WPARAM) 0, (LPARAM) 0);
             
          //-------------------------------------------------------------------                       
          // Ergebnisfeld erzeugen:
          hEdit_2 = CreateWindowEx(WS_EX_CLIENTEDGE, 
                                 "EDIT",//szClassName,//
                                 szEdit_2,//"Mehrzeileger\r\nText",
                                 WS_CHILD | WS_VISIBLE | ES_MULTILINE,
                                 240,
                                 90,
                                 210,
                                 232,
                                 hwnd,// Parent: hwnd
                                 NULL,
                                 ((LPCREATESTRUCT) lParam)->hInstance,
                                 NULL);
          if (!hEdit_2)
                MessageBox(NULL, "ZeichnungsBox konnte nicht erzeugt werden.", 
                                 "Error", MB_OK | MB_ICONERROR);
          SendMessage(hEdit_2, EM_SETREADONLY, TRUE, 0);
          //-------------------------------------------------------------------                       
          // Eingabefeld erzeugen:
          hEdit_1 = CreateWindowEx(WS_EX_CLIENTEDGE, 
                                 "EDIT",//szClassName,//
                                 "",// einzeilige Text-Feld,
                                 WS_CHILD | WS_VISIBLE,
                                 240,
                                 30,
                                 120,
                                 25,
                                 hwnd,// Parent: hwnd
                                 NULL,
                                 ((LPCREATESTRUCT) lParam)->hInstance,
                                 NULL);
          if (!hEdit_1)
                MessageBox(NULL, "ZeichnungsBox konnte nicht erzeugt werden.", 
                                 "Error", MB_OK | MB_ICONERROR);
          //-------------------------------------------------------------------                                              
          hButton_1 = CreateWindowEx(WS_EX_CONTROLPARENT, "BUTTON", "Berechnen",
                      WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON , 
                                    380, 30, 120, 25, hwnd,
                                    (HMENU)IDC_BUTTON_BERECHNEN,
                                    GetModuleHandle(NULL), NULL);
               if(hButton_1 == NULL)
                  MessageBox(hwnd,"Fehler beim Erstellen des Buttons Berechnen",
                       "Fehler !", MB_OK | MB_ICONERROR);
          
          // Men erzeugen:
          AddMenu(hwnd);
          
          // Initialisierung der Felder fr die Berechnungen:
          Init_E24();
          Init_mult();
         break;
         } 
         
        case WM_COMMAND:
             {
              // Wenn eintrag im Combofeld sich ndert:
              if(HIWORD(wParam) == CBN_SELCHANGE && (HWND)lParam == hWndComboBox)
               {
                // ItemIndex mnimmt die (Listen-Nr.-)Werte an (hier) 0-4
                i = SendMessage((HWND) lParam, (UINT) CB_GETCURSEL, 
                                            (WPARAM) 0, (LPARAM) 0);
                // Zeichnungs-Fenster lschen und neu eingestellte SchaltplanNr.
                // neu zeichnen (Funktion Inv.Rect lst WM_PAINT neu aus):
                InvalidateRect(hChild, &ChildRect, TRUE);
                SetWindowText(hEdit_2, "");
               }
              // Wenn eintrag im Combofeld sich ndert:
              if(HIWORD(wParam) == CBN_SELCHANGE && (HWND)lParam == hComboReihe)
               {
                // ItemIndex mnimmt die (Listen-Nr.-)Werte an (hier) 0-4
                iReihe = SendMessage((HWND) lParam, (UINT) CB_GETCURSEL, 
                                            (WPARAM) 0, (LPARAM) 0);
                // Zeichnungs-Fenster lschen und neu eingestellte SchaltplanNr.
                // neu zeichnen (Funktion Inv.Rect lst WM_PAINT neu aus):
                /*
                sprintf(szTestText, "EintragNr.: %i", iReihe);
                MessageBox(NULL, szTestText,"Test E12/24", MB_OK);
                */
                InvalidateRect(hChild, &ChildRect, TRUE);
                SetWindowText(hEdit_2, "");
               }
              
              switch(LOWORD(wParam))
              { 
                case IDM_HELP:
                     //DialogBox(hInst, NULL, hwnd, DlgProc));
                  if(!bDlg)
                   {
                           hWndDlg = CreateWindowEx (0,//WS_EX_CLIENTEDGE,//Extended possibilites for variation
                                            szDlgClassName,         // Classname
                                            "Hilfe",       // Title Text 
                                            WS_CAPTION | WS_SYSMENU | WS_VISIBLE,//|WS_OVERLAPPEDWINDOW, // default window 
                                            CW_USEDEFAULT,       // Windows decides the position 
                                            CW_USEDEFAULT,       // where the window ends up on the screen 
                                            500,                 // The programs width 
                                            350,                 // and height in pixels 
                                            hwnd,        // The window is a child-window to desktop 
                                            NULL,                // No menu 
                                            hInst,       // Program Instance handler 
                                            NULL                 // No Window Creation data 
                                            );
                     if(!hWndDlg)
                      {
                        MessageBox(NULL, "Konnte Dlg nicht erzeugen!", "Fehler", MB_OK);
                      }
                      SendMessage(hHelpEdit, EM_SETREADONLY, TRUE, 0);
                   
                      SetWindowText(hHelpEdit, szHilfeText);
                      bDlg = TRUE;
                     }// if(!bDlg)
                    //MessageBeep(MB_ICONWARNING);
                    /*
                     "Brauchen Sie einen genauen Widerstandswert?\r\n\r\n"
                     "Das Programm berechnet Widerstnde, aus den, je nach\r\n"
                     "Schaltung, gewnschter Widerstandswert sich ergibt.\r\n"
                     "Es probiert ALLE Werte fr jeden Widerstand durch und \r\n"
                     "gibt die Werte aus, die kleinste Abweichung zum gewn-\r\n"
                     "schtem Wert liefern.\r\n\r\nBenutzung des Programms:\r\n"
                     "Geben Sie den gewnschten Wert ein (nur Ziffern, Punkt\r\n"
                     "statt Koma),\r\n"
                     "whlen Sie eine Schaltung aus, sowie E-Reihe (E12 = 12\r\n"
                     "Werte pro Dekade oder E24 mit 24 Werten pro Dekade.\r\n"
                  "(Dekade ist z.B. von 1.0 bis 10.0, oder von 2.0 bis 20.0)\r\n"
                     "\r\nDrucken Sie auf Berechnen (Menu oder  Button\r\n"
                     "'Berechnen'). In Kurze zeigt das Programm die\r\n"
                     "Ergebnisse.\r\n"
                   "Der Text mit Ergebnissen lsst sich markieren, in die\r\n"
                "Zwichenablage kopieren und in z.B. Word-Dokument einfgen.\r\n"
                     "E24 beinhaltet E12. E24 Werte von 1.0 bis 10 sind:\r\n"
                     "1.0, 1.1, 1.2, 1.3, 1.5, 1.6, 1.8, 2.0,\r\n"
                     "2.2, 2.4, 2.7, 3.0, 3.3, 3.6, 3.9, 4.3,\r\n"
                     "4.7, 5.1, 5.6, 6.2, 6.8, 7.5, 8.2, 9.1.\r\n"
                  "E12-Werte sind 1.0, 1.2, 1.5 ... 8,2; also immer ber einen."
                  "\r\n\r\nMan beachte blo das die reele Bauteile immer ihre"
                     "\r\nToleranzen haben!"
                  "\r\n\r\nAch ja, fast vergessen! Guter Freundschaft mit\r\n"
                     "dem Programm, liebe Elektrotechniker!",*/ 
                     break;
                case IDM_INFO:
                     MessageBox(hwnd, "    R's ist Freeware!\r\n"
                                      "     Version V 1.02\r\n"
                                      "Erstellt von J.Rabe im\r\n"
                                      "           Mai 2017","Info", MB_OK);
                     break;
                     
                case IDM_BEENDEN:
                     SendMessage(hwnd, WM_CLOSE, 0, 0);
                     break;
                     
                case IDM_BERECHNEN:
                case IDC_BUTTON_BERECHNEN:
                     /****** Hier Spielt die Musik: ******/
                     // Kursor = SandUhr:
                     SetCursor(LoadCursor(NULL, IDC_WAIT));
                     SetWindowText(hEdit_2, "");
                     
                     // Einlesen des gewnschcten Wertes von "hEdit_1"-Feld aqls
                     // Text und Text in Zahl ('double') umwandeln (atof)
                     GetWindowText(hEdit_1, szEingabe, 8); 
                     R_soll = atof(szEingabe);
                     
                     // Anhand der Schaltungs-Nr. von ComboBox (i-Variable-Wert:
                     // 0-4) und entsprchende Berechnung der Widerstnde
                     switch (i)
                     {
                       case 0:
                            Ein_Resistor();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            // Text im Ausgabefeld ausgeben:
                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       case 1:
                            Zwei_in_reihe();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            sprintf(szBuffer_1, "R2 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R2);
                            strcat(szBuffer_0, stWert);
                            
                            // Text im Ausgabefeld ausgeben:
                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       case 2:
                            Zwei_Parallel();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            sprintf(szBuffer_1, "R2 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R2);
                            strcat(szBuffer_0, stWert);
                            
                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       case 3:
                            Drei_Parallel();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            sprintf(szBuffer_1, "R2 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R2);
                            strcat(szBuffer_0, stWert);// R's-Text vorbereiten:
                            
                            sprintf(szBuffer_1, "R3 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R3);
                            strcat(szBuffer_0, stWert);             

                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       case 4:
                            R1_plus_R2parR3();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            sprintf(szBuffer_1, "R2 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R2);
                            strcat(szBuffer_0, stWert);// R's-Text vorbereiten:
                            
                            sprintf(szBuffer_1, "R3 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R3);
                            strcat(szBuffer_0, stWert);    
                            
                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       case 5:
                            R1_par_zu_R2plusR3();
                            sprintf(szBuffer_0, "Rg = %.3lf Ohm\r\n\r\n", R_ist.R);
                            sprintf(szBuffer_1, "Abweichung = %.2lf Ohm\r\n", Abweichung_Alt);
                            strcat(szBuffer_0, szBuffer_1);
                            sprintf(szBuffer_1, "entspricht  %.4lf %%\r\n\r\n", 100*(R_ist.R-R_soll)/R_soll);
                            strcat(szBuffer_0, szBuffer_1);
                            
                            // R's-Text vorbereiten:
                            sprintf(szBuffer_1, "R1 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R1);
                            strcat(szBuffer_0, stWert);//R1.textR);              

                            sprintf(szBuffer_1, "R2 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R2);
                            strcat(szBuffer_0, stWert);// R's-Text vorbereiten:
                            
                            sprintf(szBuffer_1, "R3 = ");
                            strcat(szBuffer_0, szBuffer_1);
                            RtoText(R3);
                            strcat(szBuffer_0, stWert);    
                            
                            SetWindowText(hEdit_2, szBuffer_0);
                       break;
                       
                       default:
                         MessageBox(NULL, "Unbekannte Schaltung", "Berechnen?", MB_OK);
                     } 
                     // Vorbereitung des Textes zur Ausgabe (ein grosser Satz 
                     // mit mehreren Zeilenumbrchen)
                     
                     // Text-Ausgeben ins "hEdit_2"
                     /*
                     // Test (nutzt Testvariable "char buf[20]":
                       // Eingabe (gewnschter Wert) als Text einlesen,
                     GetWindowText(hEdit_1, szEingabe, 20);
                     // und in Zahl umwandeln:
                     fEingabe = atof(szEingabe);
                     // Zahl in Text umwandeln und
                     sprintf(buf,"Wert war %.2lf", fEingabe);
                     // via MeldungsDialog ausgeben:
                     MessageBox(NULL, buf,//szEingabe, 
                     "Berechnen", MB_ICONINFORMATION);
                     */
                     MessageBeep(MB_ICONWARNING);
                     SetCursor(LoadCursor(NULL, IDC_ARROW));
                     SendMessage(hEdit_2, EM_SETREADONLY, TRUE, 0);
                break;
              }
             }
            break; 
               
        case WM_PAINT:
             hdc = BeginPaint(hwnd, &ps);
             { 
               //GetClientRect(hZeichenBox, &rc);
               SetBkMode(hdc, TRANSPARENT);      
               TextOut(hdc, 30, 10, "Schaltung:", 10);   //2 Parameter von Links 3. von oben
               TextOut(hdc, 160,10, "Reihe:",6);
               TextOut(hdc, 240,10, "Gewnschter Wert:",17);
               TextOut(hdc, 250,70, "Ergebnis:",9);
             }
             EndPaint(hwnd, &ps);
            break;
              
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }// Switch ende

    return 0;
}// WindowProcedure-Ende


//-----------------------------------------------------------------
// Childfenster hat eigene Client-Area und ist wie eigenstndiges 
//(Haupt-)Fenster zu behandeln. Dieses Child-Fenster wird von Procedur-Routine 
// des HauptFensters des Programms erzeugt, welches Mutter-Fenster ist. 
// Child-Fenster braucht wegen ihrer Eigenstndigkeit eigene Procedur-Routine:
LRESULT CALLBACK ChildProc (HWND hChild, UINT message, WPARAM wParam, 
                           LPARAM lParam)
{
  PAINTSTRUCT    ps;
  HPEN           hPen;
  HBRUSH         hBrush;
  LONG           x,y;
  HDC            hdc;
  
  // Child-ClientArea einlesen und mit Hilfspunkten fllen:
  GetClientRect(hChild, &ChildRect);
             
  switch (message)
   {
      // Im Childfenster Zeichnen
      case WM_PAINT:
         {
         hdc = BeginPaint(hChild, &ps);
           {
             // Child-Fenster mit (Hilfs-)Punkten fllen:
             for(x=10;x<ChildRect.right;x=x+10)
               {
                 for(y=10;y<ChildRect.bottom;y=y+10)
                   SetPixel(hdc, x, y, RGB(0, 0, 255));
               }
      
             // Test fr R-Rechteck (soll durch Funktion erstzt werden):
             hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
             SelectObject(hdc, hPen);
             hBrush = SelectObject(hdc, CreateSolidBrush(RGB(125,192 ,192)));
             
         // Schaltung zeichnen:
         switch(i)
         {
           case 0:
                sEinResistor(hdc);
           break;
           case 1:
                sZweiReihe(hdc);
           break;
           case 2:
                sZweiParallel(hdc);
           break;
           case 3:
                sDreiParallel(hdc);
           break;
           case 4:
                sR1plusR2parR3(hdc);
           break;
           case 5:
                sR1parZuR2serR3(hdc);
           break;
           default:
           break;   
         } 
               
             //RedrawWindow(hChild,&rect,NULL, RDW_ERASE | RDW_INVALIDATE);
             //InvalidateRect(hChild, &rect, TRUE);
             
	         DeleteObject(hBrush);
             DeleteObject(hPen);            
           }
         EndPaint(hChild, &ps);
         break;
         }
      case WM_LBUTTONDOWN:
           /*
           i++;
           if (i==5)
             i=0;
           InvalidateRect(hChild, &hChildRect, TRUE);
           */
           break;
           
      default:                      /* for messages that we don't deal with */
           return DefWindowProc (hChild, message, wParam, lParam);
   }//Switch ende
   return 0;//DefWindowProc(hwnd, message, wParam, lParam);
}

LRESULT CALLBACK Edit_2_Proc(HWND hEdit_2, UINT message, 
                                 WPARAM wParam,  LPARAM lParam)
{           
  switch (message)
   {
      // Gar nichts tut es! Nur die Message weiter leiten:
      case WM_CREATE:
           break;
           
      case WM_COMMAND:
           break;
           
      case WM_LBUTTONDOWN:
           break;
           
      default:                      /* for messages that we don't deal with */
           return DefWindowProc (hEdit_2, message, wParam, lParam);
   }//Switch ende
   return 0;//DefWindowProc(hwnd, message, wParam, lParam);
}

LRESULT CALLBACK Edit_1_Proc(HWND hEdit_2, UINT message, 
                                 WPARAM wParam,  LPARAM lParam)
{           
  switch (message)
   {
      // Gar nichts tut es! Nur die Message weiter leiten:
      case WM_CREATE:
           break;
           
      case WM_COMMAND:
           break;
           
      case WM_LBUTTONDOWN:
           break;
           
      default:                      /* for messages that we don't deal with */
           return DefWindowProc (hEdit_2, message, wParam, lParam);
   }//Switch ende
   return 0;//DefWindowProc(hwnd, message, wParam, lParam);
}



//*****************************************************************************
//*************** Funktionen, die Schaltungen zeichnen ************************
//*****************************************************************************
//

//------------------------------------------------------------------------------
// Funktion zum Zeichnen der Schaltung 0
BOOL sEinResistor(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 100, 30);
     LineTo(hdc, 100, 90);
     
     MoveToEx(hdc, 100, 140, NULL);
     LineTo(hdc, 100, 210);
     LineTo(hdc, 30,210);
     
     Rectangle(hdc, 90,90, 110, 140);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 115, 105, "R1", 2);
     
     return TRUE;
}

// Funktion zum Zeichnen der Schaltung 1
BOOL sZweiReihe(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 100, 30);
     LineTo(hdc, 100, 50);
     
     MoveToEx(hdc, 100,100,NULL);
     LineTo(hdc, 100, 140);
     
     MoveToEx(hdc, 100, 190, NULL);
     LineTo(hdc, 100, 210);
     LineTo(hdc, 30,210);
     
     Rectangle(hdc, 90, 50, 110, 100);
     Rectangle(hdc, 90, 140, 110, 190);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 120, 60, "R1", 2);
     TextOut(hdc, 120, 160, "R2", 2);
     
     return TRUE;
}
//------------------------------------------------------------------------------
// Funktion zum Zeichnen der Schaltung 2
BOOL sZweiParallel(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 100, 30);
     LineTo(hdc, 100, 60);
     
     MoveToEx(hdc, 100, 180, NULL);
     LineTo(hdc, 100, 210);
     LineTo(hdc, 30,210);
     
     MoveToEx(hdc, 70, 90, NULL);
     LineTo(hdc, 70, 60);
     LineTo(hdc, 130, 60);
     LineTo(hdc, 130, 90);
     
     MoveToEx(hdc, 70, 140, NULL);
     LineTo(hdc, 70,  180);
     LineTo(hdc, 130, 180);
     LineTo(hdc, 130, 140);
     
     // Verbindungen als kleine Kreise darstellen
     //MoveToEx(hdc, 100, 60, NULL);
     Ellipse(hdc, 96,56,104,64);
     Ellipse(hdc, 96, 176, 104, 184);
     
     Rectangle(hdc, 60, 90, 80, 140);
     Rectangle(hdc, 120, 90, 140, 140);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 85, 105, "R1", 2);
     TextOut(hdc, 145, 105, "R2", 2);
     
     return TRUE;
}
//-----------------------------------------------------------------------------
// Funktion zum Zeichnen der Schaltung 3
BOOL sDreiParallel(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 100, 30);
     LineTo(hdc, 100, 90);
     
     MoveToEx(hdc, 100, 140, NULL);
     LineTo(hdc, 100, 210);
     LineTo(hdc, 30,210);
     
     MoveToEx(hdc, 50, 90,NULL);
     LineTo(hdc, 50, 60);
     LineTo(hdc, 150,60);
     LineTo(hdc, 150, 90);
     // Verbindungen als kleine Kreise darstellen
     //MoveToEx(hdc, 100, 60, NULL);
     Ellipse(hdc, 96,56,104,64);
     
     MoveToEx(hdc, 50, 140, NULL);
     LineTo(hdc, 50, 180);
     LineTo(hdc, 150, 180);
     LineTo(hdc, 150, 140);
     Ellipse(hdc, 96, 176, 104, 184);
     
     Rectangle(hdc, 40, 90, 60, 140);
     Rectangle(hdc, 90,90, 110, 140);
     Rectangle(hdc, 140, 90, 160, 140);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 65, 105, "R1", 2);
     TextOut(hdc, 115, 105, "R2", 2);
     TextOut(hdc, 165, 105, "R3", 2);
     
     return TRUE;
}
//-----------------------------------------------------------------------------
// Funktion zum Zeichnen der Schaltung 4
BOOL sR1plusR2parR3(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 100, 30);
     LineTo(hdc, 100, 50);
     
     MoveToEx(hdc, 100, 190, NULL);
     LineTo(hdc, 100, 210);
     LineTo(hdc, 30,210);
     
     MoveToEx(hdc, 70, 120, NULL);
     LineTo(hdc, 70, 110);
     LineTo(hdc, 130, 110);
     LineTo(hdc, 130, 120);
     MoveToEx(hdc, 100, 100, NULL);
     LineTo(hdc, 100, 110);
     
     MoveToEx(hdc, 70, 170, NULL);
     LineTo(hdc, 70, 190);
     LineTo(hdc, 130, 190);
     LineTo(hdc, 130, 170);
     
     Ellipse(hdc, 96, 106, 104, 114);
     Ellipse(hdc, 96, 186, 104, 194);
     
     Rectangle(hdc, 90, 50, 110, 100);
     Rectangle(hdc, 60, 120, 80, 170);
     Rectangle(hdc, 120, 120, 140, 170);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 115, 60, "R1", 2);
     TextOut(hdc, 85, 130, "R2", 2);
     TextOut(hdc, 145, 130, "R3", 2);
     
     return TRUE;
}
//-----------------------------------------------------------------------------
// Funktion zum Zeichnen der Schaltung 5
BOOL sR1parZuR2serR3(HDC hdc)
{
     MoveToEx(hdc, 30, 30, NULL);
     LineTo(hdc, 130, 30);
     LineTo(hdc, 130, 50);
     
     MoveToEx(hdc, 130,100,NULL);
     LineTo(hdc, 130, 140);
     
     MoveToEx(hdc, 130, 190, NULL);
     LineTo(hdc, 130, 210);
     LineTo(hdc, 30,210);
     
     MoveToEx(hdc, 60, 30, NULL);
     LineTo(hdc, 60, 90);
     MoveToEx(hdc, 60, 140, NULL);
     LineTo(hdc, 60, 210);
     
     Ellipse(hdc, 56, 26, 64, 34);
     Ellipse(hdc, 56, 206, 64, 214);
     
     Rectangle(hdc, 120, 50, 140, 100);
     Rectangle(hdc, 120, 140, 140, 190);
     Rectangle(hdc, 50, 90, 70, 140);
     
     SetBkMode(hdc, TRANSPARENT);
     TextOut(hdc, 75, 105,"R1", 2);
     TextOut(hdc, 145, 60, "R2", 2);
     TextOut(hdc, 145, 160, "R3", 2);
     return TRUE;
}


//*****************************************************************************
//*****************   Funktionen fr die Berechnungen   ***********************
//*****************************************************************************
///////////////////////////////////////////////////////////////////////////////
// Initialisieren E12
void Init_E24(void)
{
    E24[0]  = 0.01;  // E12
    E24[1]  = 0.011;         // E24
    E24[2]  = 0.012; // E12
    E24[3]  = 0.013;         // E24
    E24[4]  = 0.015; // E12
    E24[5]  = 0.016;
    E24[6]  = 0.018; // E12
    E24[7]  = 0.02;
    E24[8]  = 0.022; // E12
    E24[9]  = 0.024;
    E24[10] = 0.027; // E12
    E24[11] = 0.03;
    E24[12] = 0.033;
    E24[13] = 0.036;
    E24[14] = 0.039;
    E24[15] = 0.043;
    E24[16] = 0.047;
    E24[17] = 0.051;
    E24[18] = 0.056;
    E24[19] = 0.062;
    E24[20] = 0.068;
    E24[21] = 0.075;
    E24[22] = 0.082;
    E24[23] = 0.091;
}
///////////////////////////////////////////////////////////////////////////////
// Initialisieren Multiplikator-Tabelle
void Init_mult(void)
{
    Mult[0] = 1;
    Mult[1] = 10;
    Mult[2] = 100;
    Mult[3] = 1000;
    Mult[4] = 10000;
    Mult[5] = 100000;
    Mult[6] = 1000000;
    Mult[7] = 10000000;
    Mult[8] = 100000000;
}

///////////////////////////////////////////////////////////////////////////////
//  0. Zwei in Reihe
///////////////////////////////////////////////////////////////////////////////
//
void Ein_Resistor(void)
{
int r1,m1;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      R1.R = (E24[r1] * Mult[m1]);
      R_ist.R = R1.R;
            
      Abweichung_Neu = R_ist.R - R_soll;
      // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
      Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
      if(Abweichung_Neu < Abweichung_Alt)
      {
        Abweichung_Alt = Abweichung_Neu;
              
        R1.R_Wert = E24[r1];
        R1.R_Mult = Mult[m1];
        R1.E12_Nr = r1;
        R1.Mult_Nr= m1;
      }
    }//m1 Ende
    r1=r1+iReihe;
  }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  //RtoText(R1.R, R1.textR);
  R_ist.R = R1.R;
  Abweichung_Alt = R_ist.R - R_soll;
}

///////////////////////////////////////////////////////////////////////////////
//  1. Zwei in Reihe
///////////////////////////////////////////////////////////////////////////////
//
void Zwei_in_reihe(void)
{   
  int r1,m1,r2,m2;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      for(r2=0;r2<24;r2++)
      { 
        for(m2=0;m2<9;m2++)
        {   
            R1.R = (E24[r1] * Mult[m1]);
            R2.R = (E24[r2] * Mult[m2]);
            R_ist.R = R1.R + R2.R;
            
            Abweichung_Neu = R_ist.R - R_soll;
            // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
            Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
            if(Abweichung_Neu < Abweichung_Alt)
            {
              Abweichung_Alt = Abweichung_Neu;
              
              R1.R_Wert = E24[r1];
              R1.R_Mult = Mult[m1];
              R1.E12_Nr = r1;
              R1.Mult_Nr= m1;
              R2.R_Wert = E24[r2];
              R2.R_Mult = Mult[m2]; 
              R2.E12_Nr = r2;
              R2.Mult_Nr= m2;         
            }//if Ende
          }//m2 Ende
        r2=r2+iReihe;
        }//r2 Ende
      }//m1 Ende
    r1=r1+iReihe;
    }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  //RtoText(R1.R, R1.textR);
  R2.R = R2.R_Wert * R2.R_Mult;
  //RtoText(R2.R, R2.textR);
  R_ist.R = R1.R + R2.R;
  Abweichung_Alt = R_ist.R - R_soll;
}//Funktion Ende


///////////////////////////////////////////////////////////////////////////////
//  2. Zwei Parallel
///////////////////////////////////////////////////////////////////////////////
//
void Zwei_Parallel(void)
{   
  int r1,m1,r2,m2;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      for(r2=0;r2<24;r2++)
      {
        for(m2=0;m2<9;m2++)
        {   
            R1.R = (E24[r1] * Mult[m1]);
            R1.R_KW = 1/R1.R;
            R2.R = (E24[r2] * Mult[m2]);
            R2.R_KW = 1/R2.R;
            R_ist.R = 1/(R1.R_KW + R2.R_KW);
            
            Abweichung_Neu = R_ist.R - R_soll;
            
            // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
            Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
            if(Abweichung_Neu < Abweichung_Alt)
            {
              Abweichung_Alt = Abweichung_Neu;
              
              R1.R_Wert = E24[r1];
              R1.R_Mult = Mult[m1];
              R1.R_KW =1/R1.R;
              R1.E12_Nr = r1;
              R1.Mult_Nr= m1;
              R2.R_Wert = E24[r2];
              R2.R_Mult = Mult[m2];
              R2.R_KW = 1/R2.R; 
              R2.E12_Nr = r2;
              R2.Mult_Nr= m2;         
            }//if Ende
          }//m2 Ende
        r2=r2+iReihe;
        }//r2 Ende
      }//m1 Ende
    r1=r1+iReihe;
    }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  //RtoText(R1.R, R1.textR);
  R2.R = R2.R_Wert * R2.R_Mult;
  //RtoText(R2.R, R2.textR);
  R1.R_KW = 1/R1.R;
  R2.R_KW = 1/R2.R;
  R_ist.R = 1/(R1.R_KW + R2.R_KW);
  Abweichung_Alt = R_ist.R - R_soll;
}//Funktion Ende


///////////////////////////////////////////////////////////////////////////////
//  3. Drei Parallel
///////////////////////////////////////////////////////////////////////////////
//
void Drei_Parallel(void)
{
     int r1,m1,r2,m2,r3,m3;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      for(r2=0;r2<24;r2++)
      {
        for(m2=0;m2<9;m2++)
        {   
            for(r3=0;r3<24;r3++)
            {
              for(m3=0;m3<9;m3++)
              {
                R1.R = (E24[r1] * Mult[m1]);
                R1.R_KW = 1/R1.R;
                R2.R = (E24[r2] * Mult[m2]);
                R2.R_KW = 1/R2.R;
                R3.R = (E24[r3] * Mult[m3]);
                R3.R_KW = 1/R3.R;
                R_ist.R = 1/(R1.R_KW + R2.R_KW + R3.R_KW);
            
                Abweichung_Neu = R_ist.R - R_soll;
            
            // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
                Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
                if(Abweichung_Neu < Abweichung_Alt)
                {
                  Abweichung_Alt = Abweichung_Neu;
              
                  R1.R_Wert = E24[r1];
                  R1.R_Mult = Mult[m1];
                  R1.R_KW =1/R1.R;
                  R1.E12_Nr = r1;
                  R1.Mult_Nr= m1;
                  R2.R_Wert = E24[r2];
                  R2.R_Mult = Mult[m2];
                  R2.R_KW = 1/R2.R; 
                  R2.E12_Nr = r2;
                  R2.Mult_Nr= m2; 
                  R3.R_Wert = E24[r3];
                  R3.R_Mult = Mult[m3];
                  R3.R_KW =1/R3.R;
                  R3.E12_Nr = r3;
                  R3.Mult_Nr= m3;        
                  }//if Ende
              }//m3 Ende
            r3=r3+iReihe;
            }//r3 Ende
          }//m2 Ende
        r2=r2+iReihe;
        }//r2 Ende
      }//m1 Ende
    r1=r1+iReihe;
    }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  //RtoText(R1.R, R1.textR);
  R2.R = R2.R_Wert * R2.R_Mult;
  //RtoText(R2.R, R2.textR);
  R3.R = R3.R_Wert * R3.R_Mult;
  //RtoText(R3.R, R3.textR);
  R1.R_KW = 1/R1.R;
  R2.R_KW = 1/R2.R;
  R3.R_KW = 1/R3.R;
  R_ist.R = 1/(R1.R_KW + R2.R_KW + R3.R_KW);
  Abweichung_Alt = R_ist.R - R_soll;
}//Funktion Ende


///////////////////////////////////////////////////////////////////////////////
//  4. R1 in Reihe zu Parallelschaltung aus R2 und R3
///////////////////////////////////////////////////////////////////////////////
//
void R1_plus_R2parR3(void)
{   
  int r1,m1,r2,m2,r3,m3;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      for(r2=0;r2<24;r2++)
      {
        for(m2=0;m2<9;m2++)
        {   
            for(r3=0;r3<24;r3++)
            {
              for(m3=0;m3<9;m3++)
              {
                R1.R = (E24[r1] * Mult[m1]);
                R2.R = (E24[r2] * Mult[m2]);
                R2.R_KW = 1/R2.R;
                R3.R = (E24[r3] * Mult[m3]);
                R3.R_KW = 1/R3.R;
                R_ist.R = R1.R + 1/(R2.R_KW + R3.R_KW);
            
                Abweichung_Neu = R_ist.R - R_soll;
            
            // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
                Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
                if(Abweichung_Neu < Abweichung_Alt)
                {
                  Abweichung_Alt = Abweichung_Neu;
              
                  R1.R_Wert = E24[r1];
                  R1.R_Mult = Mult[m1];
                  R1.R_KW =1/R1.R;
                  R1.E12_Nr = r1;
                  R1.Mult_Nr= m1;
                  R2.R_Wert = E24[r2];
                  R2.R_Mult = Mult[m2];
                  R2.R_KW = 1/R2.R; 
                  R2.E12_Nr = r2;
                  R2.Mult_Nr= m2; 
                  R3.R_Wert = E24[r3];
                  R3.R_Mult = Mult[m3];
                  R3.R_KW =1/R3.R;
                  R3.E12_Nr = r3;
                  R3.Mult_Nr= m3;        
                  }//if Ende
              }//m3 Ende
            r3=r3+iReihe;
            }//r3 Ende
          }//m2 Ende
        r2=r2+iReihe;
        }//r2 Ende
      }//m1 Ende
    r1=r1+iReihe;
    }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  //RtoText(R1.R, R1.textR);
  R2.R = R2.R_Wert * R2.R_Mult;
  //RtoText(R2.R, R2.textR);
  R3.R = R3.R_Wert * R3.R_Mult;
  //RtoText(R3.R, R3.textR);
  R2.R_KW = 1/R2.R;
  R3.R_KW = 1/R3.R;
  R_ist.R = R1.R + 1/(R2.R_KW + R3.R_KW);
  Abweichung_Alt = R_ist.R - R_soll;
}//Funktion Ende

            
///////////////////////////////////////////////////////////////////////////////
//  4. R1 in Reihe zu Parallelschaltung aus R2 und R3
///////////////////////////////////////////////////////////////////////////////
//
void R1_par_zu_R2plusR3(void)
{   
  int r1,m1,r2,m2,r3,m3;
  double R23, R23_KW;

  Abweichung_Alt= 100000000; // Abweichung alt
  
  for(r1=0;r1<24;r1++)
  {
    for(m1=0;m1<9;m1++)
    {
      for(r2=0;r2<24;r2++)
      {
        for(m2=0;m2<9;m2++)
        {   
            for(r3=0;r3<24;r3++)
            { 
              for(m3=0;m3<9;m3++)
              {
                R1.R = (E24[r1] * Mult[m1]);
                R1.R_KW = 1/R1.R;
                R2.R = (E24[r2] * Mult[m2]);
                R3.R = (E24[r3] * Mult[m3]);
                R23 = R2.R + R3.R;
                R23_KW = 1/R23;
                R_ist.R = 1/(R1.R_KW + R23_KW);
            
                Abweichung_Neu = R_ist.R - R_soll;
            
            // "Abweichung_Neu" positiv machen (Quadrieren, dann Wurzel ziehen:
                Abweichung_Neu = sqrt(Abweichung_Neu*Abweichung_Neu);
            
                if(Abweichung_Neu < Abweichung_Alt)
                {
                  Abweichung_Alt = Abweichung_Neu;
              
                  R1.R_Wert = E24[r1];
                  R1.R_Mult = Mult[m1];
                  R1.R_KW =1/R1.R;
                  R1.E12_Nr = r1;
                  R1.Mult_Nr= m1;
                  R2.R_Wert = E24[r2];
                  R2.R_Mult = Mult[m2];
                  R2.R_KW = 1/R2.R; 
                  R2.E12_Nr = r2;
                  R2.Mult_Nr= m2; 
                  R3.R_Wert = E24[r3];
                  R3.R_Mult = Mult[m3];
                  R3.R_KW =1/R3.R;
                  R3.E12_Nr = r3;
                  R3.Mult_Nr= m3;        
                  }//if Ende
              }//m3 Ende
            r3=r3+iReihe;
            }//r3 Ende
          }//m2 Ende
        r2=r2+iReihe;
        }//r2 Ende
      }//m1 Ende
    r1=r1+iReihe;
    }//r1 Ende
  R1.R = R1.R_Wert * R1.R_Mult;
  R1.R_KW = 1/R1.R;
  //RtoText(R1.R, R1.textR);
  R2.R = R2.R_Wert * R2.R_Mult;
  //RtoText(R2.R, R2.textR);
  R3.R = R3.R_Wert * R3.R_Mult;
  //RtoText(R3.R, R3.textR);
  R23  = R2.R + R3.R;
  R23_KW = 1/R23;
  R_ist.R = 1/(R1.R_KW + R23_KW);
  Abweichung_Alt = R_ist.R - R_soll;
}//Funktion Ende

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----------------------------------------------------------------------------
// Funktion:  void RtoText(dR, tR)
// Zweck:     Wandelt Widerstandswert R in gut lesberen Text um:
void RtoText(struct RESISTORDATA sR)
{
  double r;
     
  switch (sR.Mult_Nr)
  {
    case 0: // (zB. 0,015) *1
         sprintf(sR.textR, "%.3lf Ohm\r\n", sR.R);
    break;
    case 1: // (zB. 0,022) *10
         sprintf(sR.textR, "%.2lf Ohm\r\n", sR.R);
    break;
    case 2: // (zB. 0,022) *100 = 2,2 Ohm
         sprintf(sR.textR, "%.1lf Ohm\r\n", sR.R);
    break;
    case 3: // *1000 (=22 Ohm)
    case 4: // *10.000 (=220 Ohm)
         sprintf(sR.textR, "%.0lf Ohm\r\n", sR.R);
    break;
    case 5: // *100.000 (=2,2k)
         r = sR.R/1000;
         sprintf(sR.textR, "%.1lf kOhm\r\n", r);
    break;
    case 6: // *1.000.000 (=22k)
    case 7: // *10.000.000 (=220k)
         r = sR.R/1000;
         sprintf(sR.textR, "%.0lf kOhm\r\n", r);
    break;
    case 8: // *100.000.000 (=2,2 MOhm)
         r = sR.R/1000000;
         sprintf(sR.textR, "%.1lf MOhm\r\n", r);
    break;
  }
  sprintf(stWert, sR.textR);
  //MessageBox(NULL, sR.textR, "Test in Funktion", MB_OK);
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++   Menu erzeugen:   ++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void AddMenu(HWND hwnd)
{
  HMENU hMenubar; // Ganzes Men
  HMENU hMenu_Spalte_1;
  HMENU hMenu_Spalte_2;
  
  hMenubar = CreateMenu();
  hMenu_Spalte_1 = CreateMenu();
  hMenu_Spalte_2 = CreateMenu();
    
    // MF_POPUP = aufklappbare Men-Element,
    // MF_SEPARATOR = Trennlinie,
    // MF_STRING = String = Zeichenkette
    //---------   erste Spalte   ----------------------
    AppendMenu(hMenubar, MF_POPUP, (UINT_PTR) hMenu_Spalte_1, "&Menu");
    
    AppendMenu(hMenu_Spalte_1, MF_STRING, IDM_BERECHNEN, "Berechnen");
    AppendMenu(hMenu_Spalte_1, MF_SEPARATOR, 0, NULL);
    AppendMenu(hMenu_Spalte_1, MF_STRING, IDM_BEENDEN, "Beenden");
    
    //---------   Zweite Spalte   ---------------------
    AppendMenu(hMenubar, MF_POPUP, (UINT_PTR) hMenu_Spalte_2, "?");
    
    AppendMenu(hMenu_Spalte_2, MF_STRING, IDM_HELP, "Hilfe");
    AppendMenu(hMenu_Spalte_2, MF_SEPARATOR, 0, NULL);
    AppendMenu(hMenu_Spalte_2, MF_STRING, IDM_INFO, "Info");
    
    SetMenu(hwnd, hMenubar);
}

//=============================================================================
//******************   DialogBox "Hilfe"   ************************************
LRESULT CALLBACK HelpDlgProc (HWND hWndDlg, UINT Msg, WPARAM wParam, 
                                 LPARAM lParam)
{
//PAINTSTRUCT ps;
//HDC         hdc;

	switch(Msg)
	{
	case WM_CREATE:
         hHelpEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", 
                                                      "Hilfe",
                                    WS_VSCROLL | WS_CHILD | WS_VISIBLE | ES_MULTILINE, 
                                    CW_USEDEFAULT, CW_USEDEFAULT, 490, 320, hWndDlg,
                                    NULL,//(HMENU)IDC_WERT_EDIT,
                                    GetModuleHandle(NULL), NULL);
         if(hHelpEdit == NULL)
              MessageBox(hWndDlg,"Fehler beim Erstellen des Editor-Fensters",
                                  "Fehler !", MB_OK | MB_ICONERROR);
               
         // Editfeld nur lesbar (Read only) machen:
         SendMessage(hHelpEdit, EM_SETREADONLY, TRUE, 0);
		break;
//	case WM_PAINT:
//         hdc = BeginPaint(hHelpEdit, &ps);
//         //SetBkColor(hdc, RGB(255,255,255)); 
//         EndPaint(hHelpEdit, &ps);
//         break;
    case WM_DESTROY:
            bDlg = FALSE;
            MessageBeep(MB_ICONWARNING);
    break;
    
	default:
	  return DefWindowProc (hWndDlg, Msg, wParam, lParam);
    }
}











